Loading...
Searching...
No Matches
juce::LocalisedStrings Class Reference

## Detailed Description

Used to convert strings to localised foreign-language versions.

This is basically a look-up table of strings and their translated equivalents. It can be loaded from a text file, so that you can supply a set of localised versions of strings that you use in your app.

To use it in your code, simply call the translate() method on each string that might have foreign versions, and if none is found, the method will just return the original string.

The translation file should start with some lines specifying a description of the language it contains, and also a list of ISO country codes where it might be appropriate to use the file. After that, each line of the file should contain a pair of quoted strings with an '=' sign.

E.g. for a french translation, the file might be:

language: French
countries: fr be mc ch lu
"hello" = "bonjour"
"goodbye" = "au revoir"

If the strings need to contain a quote character, they can use " instead, and if the first non-whitespace character on a line isn't a quote, then it's ignored, (you can use this to add comments).

Note that this is a singleton class, so don't create or destroy the object directly. There's also a TRANS (text) macro defined to make it easy to use the this.

printSomething (TRANS ("hello"));
TRANS
#define TRANS(stringLiteral)
Uses the LocalisedStrings class to translate the given string literal.
Definition juce_LocalisedStrings.h:220

This macro is used in the JUCE classes themselves, so your application has a chance to intercept and translate any internal JUCE text strings that might be shown. (You can easily get a list of all the messages by searching for the TRANS() macro in the JUCE source code).

The documentation for this class was generated from the following file:

- juce_core/text/juce_LocalisedStrings.h

## Public Member Functions

| LocalisedStrings (const String &fileContents, bool ignoreCaseOfKeys)
| Creates a set of translations from the text of a translation file.
| LocalisedStrings (const File &fileToLoad, bool ignoreCaseOfKeys)
| Creates a set of translations from a file.
| LocalisedStrings (const LocalisedStrings &)
LocalisedStrings & | operator= (const LocalisedStrings &)
| ~LocalisedStrings ()=default
| Destructor.
String | translate (const String &text) const
| Attempts to look up a string and return its localised version.
String | translate (const String &text, const String &resultIfNotFound) const
| Attempts to look up a string and return its localised version.
String | getLanguageName () const
| Returns the name of the language specified in the translation file.
const StringArray & | getCountryCodes () const
| Returns the list of suitable country codes listed in the translation file.
const StringPairArray & | getMappings () const
| Provides access to the actual list of mappings.
void | addStrings (const LocalisedStrings &)
| Adds and merges another set of translations into this set.
void | setFallback (LocalisedStrings *fallbackStrings)
| Gives this object a set of strings to use as a fallback if a string isn't found.

## Static Public Member Functions

static void | setCurrentMappings (LocalisedStrings *newTranslations)
| Selects the current set of mappings to be used by the system.
static LocalisedStrings * | getCurrentMappings ()
| Returns the currently selected set of mappings.
static String | translateWithCurrentMappings (const String &text)
| Tries to translate a string using the currently selected set of mappings.
static String | translateWithCurrentMappings (const char *text)
| Tries to translate a string using the currently selected set of mappings.

## Constructors and Destructors

## LocalisedStrings() [1/3]

juce::LocalisedStrings::LocalisedStrings | ( | const String & | fileContents,
|  | bool | ignoreCaseOfKeys )

Creates a set of translations from the text of a translation file.

When you create one of these, you can call setCurrentMappings() to make it the set of mappings that the system's using.

Referenced by addStrings(), getCurrentMappings(), LocalisedStrings(), operator=(), setCurrentMappings(), and setFallback().

## LocalisedStrings() [2/3]

juce::LocalisedStrings::LocalisedStrings | ( | const File & | fileToLoad,
|  | bool | ignoreCaseOfKeys )

Creates a set of translations from a file.

When you create one of these, you can call setCurrentMappings() to make it the set of mappings that the system's using.

## LocalisedStrings() [3/3]

juce::LocalisedStrings::LocalisedStrings | ( | const LocalisedStrings & |  | ) |

References LocalisedStrings().

## ~LocalisedStrings()

juce::LocalisedStrings::~LocalisedStrings | ( |  | ) |

default

Destructor.

## Member Functions

## operator=()

LocalisedStrings & juce::LocalisedStrings::operator= | ( | const LocalisedStrings & |  | ) |

References LocalisedStrings().

## setCurrentMappings()

void juce::LocalisedStrings::setCurrentMappings | ( | LocalisedStrings * | newTranslations | ) |

static

Selects the current set of mappings to be used by the system.

The object you pass in will be automatically deleted when no longer needed, so don't keep a pointer to it. You can also pass in nullptr to remove the current mappings.

See also the TRANS() macro, which uses the current set to do its translation.

See also
  translateWithCurrentMappings

References LocalisedStrings().

## getCurrentMappings()

LocalisedStrings * juce::LocalisedStrings::getCurrentMappings | ( |  | ) |

static

Returns the currently selected set of mappings.

This is the object that was last passed to setCurrentMappings(). It may be nullptr if none has been created.

References LocalisedStrings().

## translateWithCurrentMappings() [1/2]

String juce::LocalisedStrings::translateWithCurrentMappings | ( | const String & | text | ) |

static

Tries to translate a string using the currently selected set of mappings.

If no mapping has been set, or if the mapping doesn't contain a translation for the string, this will just return the original string.

See also the TRANS() macro, which uses this method to do its translation.

See also
  setCurrentMappings, getCurrentMappings

## translateWithCurrentMappings() [2/2]

String juce::LocalisedStrings::translateWithCurrentMappings | ( | const char * | text | ) |

static

Tries to translate a string using the currently selected set of mappings.

If no mapping has been set, or if the mapping doesn't contain a translation for the string, this will just return the original string.

See also the TRANS() macro, which uses this method to do its translation.

See also
  setCurrentMappings, getCurrentMappings

## translate() [1/2]

String juce::LocalisedStrings::translate | ( | const String & | text | ) | const

Attempts to look up a string and return its localised version.

If the string isn't found in the list, the original string will be returned.

## translate() [2/2]

String juce::LocalisedStrings::translate | ( | const String & | text,
|  | const String & | resultIfNotFound ) const

Attempts to look up a string and return its localised version.

If the string isn't found in the list, the resultIfNotFound string will be returned.

## getLanguageName()

String juce::LocalisedStrings::getLanguageName | ( |  | ) | const

inline

Returns the name of the language specified in the translation file.

This is specified in the file using a line starting with "language:", e.g.

language: german

## getCountryCodes()

const StringArray & juce::LocalisedStrings::getCountryCodes | ( |  | ) | const

inline

Returns the list of suitable country codes listed in the translation file.

These is specified in the file using a line starting with "countries:", e.g.

countries: fr be mc ch lu

The country codes are supposed to be 2-character ISO compliant codes.

## getMappings()

const StringPairArray & juce::LocalisedStrings::getMappings | ( |  | ) | const

inline

Provides access to the actual list of mappings.

## addStrings()

void juce::LocalisedStrings::addStrings | ( | const LocalisedStrings & |  | ) |

Adds and merges another set of translations into this set.

Note that the language name and country codes of the new LocalisedStrings object must match that of this object - an assertion will be thrown if they don't match.

Any existing values will have their mappings overwritten by the new ones.

References LocalisedStrings().

## setFallback()

void juce::LocalisedStrings::setFallback | ( | LocalisedStrings * | fallbackStrings | ) |

Gives this object a set of strings to use as a fallback if a string isn't found.

The object that is passed-in will be owned and deleted by this object when no longer needed. It can be nullptr to clear the existing fallback object.

References LocalisedStrings().

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited